#ifndef _AISA15_H_
#define _AISA15_H_

#ifdef __cplusplus
extern "C" {
#endif

// őXbg
#define	AISA15_MAX_SLOTS				16

// _Xbgw
#define	AISA15_SLOT_AUTO				((WORD) ~0U)

// G[R[h̒`
#define	AISA15_ERR_INTERNAL				5100	// Send mail to us
#define	AISA15_ERR_UNKNOWN				5101	// Help me!
#define	AISA15_SUCCESS					0		// I
#define	AISA15_ERR_NO_DEVICE			5000	// No device or not an aISA-A15
#define	AISA15_ERR_RESOURCE				5001	// Resource exhaustion
#define	AISA15_ERR_INVALID_ARG			5002	// Invalid argument(s)
#define	AISA15_ERR_SLOT					5003	// _Xbgԍsłi܂͌܂j
#define	AISA15_ERR_CHANNEL				5004	// `lw肪sł
#define	AISA15_ERR_TIMER				5005	// ^C}lsł
#define	AISA15_ERR_DMA_BUFFSIZE			5006	// DMA]TCYsł
#define	AISA15_ERR_NOT_ENOUGH_MEM		5007	// \ȃmۂł܂ł
#define	AISA15_ERR_DMA					5008	// DMA͎gpł܂
#define	AISA15_ERR_NUMDATA				5009	// w肳ꂽ̃f[^obt@ɑ݂܂
#define	AISA15_ERR_NOT_CREATED			5010	// foCXNGCgĂ܂
#define	AISA15_ERR_START				5011	// X^[gɎs܂
#define	AISA15_ERR_INVALID_FUNC			5012	// Ȋ֐Ăяoł
#define	AISA15_ERR_IN_USE				5013	// gp̃foCXł

// TvO[h̒`
											// START  SAMPLING	TRANSFER  CLK
#define	MODE_01							1	// soft	  single	port	  ---
#define	MODE_02							2	// soft	  single	port	  EXTRG
#define	MODE_03							3	// soft	  burst		port	  timer
#define	MODE_04							4	// soft	  burst		port	  EXTRG
#define	MODE_05							5	// soft	  burst		DMA		  timer
#define	MODE_06							6	// EXIN0  single	port	  ---
#define	MODE_07							7	// EXIN0  single	port	  EXTRG
#define	MODE_08							8	// EXIN0  burst		port	  timer
#define	MODE_09							9	// EXIN0  burst		port	  EXTRG
#define	MODE_10							10	// EXIN0  burst		DMA		  timer

// bZ[W
#define	WM_EOC						0	// VOTvO̊
#define	WM_BUFF_HALF_FULL			1	// VxDOobt@̃n[tt
#define	WM_BUFF_FULL				2	// VxDOobt@̃t
#define	WM_BUFF_OVERFLOW			3	// VxDOobt@̃I[o[t[
#define	WM_SAMPLING_OVERRUN			4	// `lEI[gECNg̃I[o[
#define	WM_DMA_TC					5	// DMA]

// ***** I/O\[X\ *****
// YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B
typedef struct _AISA15RESOURCE_NT {
	DWORD	dwIOPortBase;			// I/O|[gJnAhX
	DWORD	dwIRQRegisters;			// IRQԍ
	DWORD	dwNumDMAs;				// DMA`l
	DWORD	dwDMALst;				// DMA`l
} AISA15RESOURCE_NT, *PAISA15R_NT;


// ***** TvO[h\ *****
// YfoCX̃TvO[hɊւVxD֓n߂̍\́B
// iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB
typedef struct _AISA15MODE {
	DWORD	iChFirst;		// TvOJn`l(0 ` 15)
	DWORD	iChLast;		// TvOI`l(0 ` 15)
	DWORD	cwBuffer;		// obt@TCYi[hPʁj
	DWORD	dwTimer;		// ^C}l(1`50000000)
	DWORD	dwMode;			// 샂[h(1`12)
} AISA15MODE, *PCAISA15M;


// foCX̎gp錾
BOOL
WINAPI
Aisa15Create(
	LPWORD		lpwLogSlot,				// _Xbgw
	HWND		hwnd,					// bZ[W󂯎EBhEnh
	UINT		uWMBase,				// bZ[WID̊l
	LPVOID		lpvInitArg);			// ̂߂̗\


// foCX̊J錾
BOOL
WINAPI
Aisa15Close(
	WORD		wLogSlot);				// _Xbgw


// foCXhCoDLL̃o[W擾
BOOL
WINAPI
Aisa15GetVersion(
	LPDWORD		lpdwDllVer,				// DLL̃o[W
	LPDWORD		lpdwDrvVer);			// Driver̃o[W


// I/O\[X̎擾
BOOL
WINAPI
Aisa15GetResource(
	WORD		wLogSlot,				// _Xbg
	PAISA15R_NT	pres);					// \[X


// TvO[h̐ݒ
BOOL
WINAPI
Aisa15SetMode(
	WORD		wLogSlot,				// _Xbg
	PCAISA15M	pcmode);				// [hݒf[^


// TvOJn
BOOL
WINAPI
Aisa15StartSampling(
	WORD		wLogSlot);				// _Xbg


// TvO~
BOOL
WINAPI
Aisa15StopSampling(
	WORD		wLogSlot);				// _Xbg


// TvOEXe[^X̎擾
BOOL
WINAPI
Aisa15GetSamplingStatus(
	WORD		wLogSlot,				// _Xbg
	LPDWORD		lpcwNumData,			// f[^obt@|C^
	LPDWORD		lpdwStatus);			// Xe[^X


// TvOς݃f[^̎擾
BOOL
WINAPI
Aisa15GetData(
	WORD		wLogSlot,				// _Xbg
	DWORD		cwNumData,				// vf[^
	LPWORD		lpwData);				// f[^obt@ւ̃|C^


// G[R[h̎擾
DWORD
WINAPI
Aisa15GetLastError(
	WORD		wLogSlot);				// _Xbg


// O͏Ԃ̎擾
BOOL
WINAPI
Aisa15GetExIn(
	WORD		wLogSlot,				// _Xbg
	LPDWORD		lpdwExIn0,				// EXIN0̏
	LPDWORD		lpdwExIn1,				// EXIN1̏
	LPDWORD		lpdwExTrg);				// EXTRG̏


#ifdef __cplusplus
}
#endif

#endif
